//###############################################################################################################################################
//
//	Object Constraint Language Generic Manager
//	OCLCommon.h
//
//###############################################################################################################################################

#ifndef OCLCommon_h
#define OCLCommon_h

#include <stl_config.h>

#include "vector"
#include "map"
#include "set"
#include "string"
#include "stdio.h"

#define TABSTR "    "

typedef vector< string >	StringVector;
typedef StringVector			TypeSeq;

bool operator!=( const string& str1, const string& str2 );

struct Position
{
	int iLine;
	int iColumn;
};

string& Trim( string& strIn );

typedef map< int , Position > PositionMap;

namespace OclCommon {

	void Convert( const TypeSeq& ts, string& s );
	int Convert( const string& s, TypeSeq& ts );

}; // namespace OclCommon

#endif OCLCommon_h