// MgaConnection.h : Declaration of the CMgaConnection

#ifndef __MGACONNECTION_H_
#define __MGACONNECTION_H_

#include "resource.h"       // main symbols
#include "MgaFCO.h"

/////////////////////////////////////////////////////////////////////////////
// CMgaConnection



//##ModelId=3C5AA09A0248
class ATL_NO_VTABLE CMgaConnection : 
	public CComCoClass<CMgaConnection, &CLSID_MgaSimpleConnection>,
	public IMgaFCOImpl< 
		CComObjectRootEx<CComSingleThreadModel>,
		IDispatchImpl<IMgaSimpleConnection, &IID_IMgaSimpleConnection, &LIBID_MGALib> >,
	public ISupportErrorInfoImpl<&IID_IMgaConnection>
{
public:
	//##ModelId=3C5AA09A0311
	static HRESULT WINAPI simpletest(void* pv, REFIID riid, LPVOID* ppv, DWORD dw) {
				FCO *f = reinterpret_cast<CMgaConnection*>(pv)->innFCO;
				if(!f->simpleconn()) return E_NOINTERFACE;
				IUnknown* pUnk = (IUnknown*)((int)pv+dw);
				pUnk->AddRef();
				*ppv = pUnk;
				return S_OK;
	}

	//##ModelId=3C5AA09A0325
	CMgaConnection() {	}

	
DECLARE_PROTECT_FINAL_CONSTRUCT()

BEGIN_COM_MAP(CMgaConnection)
	COM_INTERFACE_ENTRY(IMgaConnection)
	COM_INTERFACE_ENTRY(IDispatch)
	COM_INTERFACE_ENTRY_IID(IID_IMgaFCO,IMgaConnection)
	COM_INTERFACE_ENTRY_IID(IID_IMgaObject,IMgaConnection)
	COM_INTERFACE_ENTRY_IID(IID_ISupportErrorInfo, IMyErrorInfoBase)
	COM_INTERFACE_ENTRY_FUNC(IID_IMgaSimpleConnection, offsetofclass(IMgaSimpleConnection, _ComMapClass), simpletest)
END_COM_MAP()

// IMgaSimpleConnection
public:
	//##ModelId=3C5AA09A0326
	HRESULT findroleobj(BSTR rolename, ICoreObject **tt);

	//##ModelId=3C5AA09A0339
	STDMETHOD(get_NamedRole)(BSTR rolename, IMgaFCO **pVal) { 
											return inFCO->get_NamedRoleTarget(rolename,pVal); }
	//##ModelId=3C5AA09A0344
	STDMETHOD(get_NamedRoleReferences)(BSTR rolename, IMgaFCOs **pVal) {
											return inFCO->get_NamedRoleReferences( rolename,pVal); }

	//##ModelId=3C5AA09A0357
	STDMETHOD(get_Src)(IMgaFCO **pVal) { return inFCO->get_NamedRoleTarget(inFCO->SrcName, pVal); }
	//##ModelId=3C5AA09A0362
	STDMETHOD(get_Dst)(IMgaFCO **pVal) { return inFCO->get_NamedRoleTarget(inFCO->DstName, pVal); }
	//##ModelId=3C5AA09A036D
	STDMETHOD(get_SrcReferences)(IMgaFCOs **pVal) { return get_NamedRoleReferences(inFCO->SrcName, pVal); }
	//##ModelId=3C5AA09A037F
	STDMETHOD(get_DstReferences)(IMgaFCOs **pVal) { return get_NamedRoleReferences(inFCO->DstName, pVal); }

	//##ModelId=3C5AA09A0389
	STDMETHOD(SetSrc)(IMgaFCOs *refs, IMgaFCO * newVal)  { 
										return inFCO->put_NamedRole(inFCO->SrcName, refs, newVal); }
	//##ModelId=3C5AA09A0394
	STDMETHOD(SetDst)(IMgaFCOs *refs, IMgaFCO * newVal) { 
										return inFCO->put_NamedRole(inFCO->DstName, refs, newVal); }
	//##ModelId=3C5AA09A03A7
	STDMETHOD(AddConnPoint)(BSTR rolename, long maxinrole, IMgaFCO *target, IMgaFCOs *refs, IMgaConnPoint **pVal) {
										return inFCO->AddConnPoint(rolename, maxinrole, target, refs, pVal); }
	//##ModelId=3C5AA09A03C5
	STDMETHOD(get_ConnPoints)(IMgaConnPoints **pVal) {
										return inFCO->get_ConnPoints(pVal); }

	//##ModelId=3C5AA09A03CF
	STDMETHOD(CompareToBase)(IMgaConnPoint *p, short *status)		{ return inFCO->ConnCompareToBase(p,status); }
	//##ModelId=3C5AA09A03DB
    STDMETHOD(RevertToBase)(IMgaConnPoint *p)						{ return inFCO->ConnRevertToBase(p); }
};



/////////////////////////////////////////////////////////////////////////////
// CMgaConnPoint
//##ModelId=3C5AA09B0037
class ATL_NO_VTABLE CMgaConnPoint : 
	public CComCoClass<CMgaConnPoint, &CLSID_MgaConnPoint>,
	public CComObjectRootEx<CComSingleThreadModel>,
	public IDispatchImpl<IMgaConnPoint, &IID_IMgaConnPoint, &LIBID_MGALib>,
	public ISupportErrorInfoImpl<&IID_IMgaConnPoint>
{
public:
	DEFSIG;
	//##ModelId=3C5AA09B0113
	CMgaConnPoint()	{
		INITSIG('C');
	}

	//##ModelId=3C5AA09B011E
	CComPtr<FCO> fco;
	//##ModelId=3C5AA09B0128
	CoreObj cobj;
	//##ModelId=3C5AA09B013B
	static void GetConnPoint(FCO *f, CoreObj &c, IMgaConnPoint **cp);
	//##ModelId=3C5AA09B0159
	~CMgaConnPoint();

DECLARE_PROTECT_FINAL_CONSTRUCT()

BEGIN_COM_MAP(CMgaConnPoint)
	COM_INTERFACE_ENTRY(IMgaConnPoint)
	COM_INTERFACE_ENTRY(IDispatch)
	COM_INTERFACE_ENTRY_IID(IID_ISupportErrorInfo, IMyErrorInfoBase)
END_COM_MAP()

// IMgaConnPoint
public:
	//##ModelId=3C5AA09B015A
	STDMETHOD(get_Owner)(IMgaConnection **pVal);
	//##ModelId=3C5AA09B016D
	STDMETHOD(get_ConnRole)(BSTR *pVal);
	//##ModelId=3C5AA09B0177
	STDMETHOD(put_ConnRole)(BSTR newVal);
	//##ModelId=3C5AA09B018B
	STDMETHOD(get_Target)(IMgaFCO **pVal);
	//##ModelId=3C5AA09B0195
	STDMETHOD(get_References)(IMgaFCOs **pVal);
	//##ModelId=3C5AA09B01A1
	STDMETHOD(Remove)();
};

//##ModelId=3C5AA09B01BE
class RemoveConnPTask : public DeriveTreeTask {
	//##ModelId=3C5AA09B01C9
	bool Do(CoreObj self, vector<CoreObj> *peers = NULL);
};


#endif //__MGACONNECTION_H_
