// MgaFilter.h : Declaration of the CMgaFilter

#ifndef __MGAFILTER_H_
#define __MGAFILTER_H_

#include "resource.h"       // main symbols
#include "MgaFCO.h"



/////////////////////////////////////////////////////////////////////////////
// CMgaFilter
//##ModelId=3C5AA0900103
class ATL_NO_VTABLE CMgaFilter : 
	public CComObjectRootEx<CComSingleThreadModel>,
	public CComCoClass<CMgaFilter, &CLSID_MgaFilter>,
	public IDispatchImpl<IMgaFilter, &IID_IMgaFilter, &LIBID_MGALib>,
	public ISupportErrorInfoImpl<&IID_IMgaFilter>
{
public:
	//##ModelId=3C5AA09001A6
	CMgaFilter()
	{
		levels = objtypes = 0;
		newlevel = newobjtype = newrole = newkind = newname = false;
	}


DECLARE_PROTECT_FINAL_CONSTRUCT()

BEGIN_COM_MAP(CMgaFilter)
	COM_INTERFACE_ENTRY(IMgaFilter)
	COM_INTERFACE_ENTRY(IDispatch)
	COM_INTERFACE_ENTRY_IID(IID_ISupportErrorInfo, IMyErrorInfoBase)
END_COM_MAP()

private:
	CComBSTR level, objtype, role, kind, name;
	bool newlevel, newobjtype, newrole, newkind, newname;
	//##ModelId=3C5AA09001AE
	unsigned long levels;
	//##ModelId=3C5AA09001B8
	unsigned long objtypes;
	//##ModelId=3C5AA09002C6
	typedef hash_set<CComBSTRNoAt, CComBSTR_hashfunc> BSTRhash;
	//##ModelId=3C5AA09002DA
	typedef hash_set<metaref_type, metaref_hashfunc> mrefhash;
	mrefhash rolenums, kindnums;
	BSTRhash rolenames, kindnames, names;
	//##ModelId=3C5AA09001CD
	CMgaProject *mgaproject;
// IMgaFilter
public:
	//##ModelId=3C5AA09001D6
	STDMETHOD(get_Level)(BSTR *pVal);
	//##ModelId=3C5AA09001EA
	STDMETHOD(put_Level)(BSTR newVal);
	//##ModelId=3C5AA09001F4
	STDMETHOD(get_ObjType)(BSTR *pVal);
	//##ModelId=3C5AA0900200
	STDMETHOD(put_ObjType)(BSTR newVal);
	//##ModelId=3C5AA0900212
	STDMETHOD(get_Role)(BSTR *pVal);
	//##ModelId=3C5AA090021C
	STDMETHOD(put_Role)(BSTR newVal);
	//##ModelId=3C5AA0900228
	STDMETHOD(get_Kind)(BSTR *pVal);
	//##ModelId=3C5AA090023A
	STDMETHOD(put_Kind)(BSTR newVal);
	//##ModelId=3C5AA0900245
	STDMETHOD(get_Name)(BSTR *pVal);
	//##ModelId=3C5AA0900258
	STDMETHOD(put_Name)(BSTR newVal);
	//##ModelId=3C5AA0900262
	STDMETHOD(get_Project)(IMgaProject **pVal);
	

	void searchFCOs(CoreObj &self, EXCOLLECTIONTYPE_FOR(MgaFCO) *retcoll, int level = 0);
	//##ModelId=3C5AA090026D
	void init();
	//##ModelId=3C5AA09002B2
	void setproject(CMgaProject *p ) { mgaproject = p; }
};

#endif //__MGAFILTER_H_
