// MgaReference.h : Declaration of the CMgaReference

#ifndef __MGAREFERENCE_H_
#define __MGAREFERENCE_H_

#include "resource.h"       // main symbols
#include "MgaFCO.h"

/////////////////////////////////////////////////////////////////////////////
// CMgaReference
//##ModelId=3C5AA0890320
class ATL_NO_VTABLE CMgaReference : 
	public CComCoClass<CMgaReference, &CLSID_MgaReference>,
	public IMgaFCOImpl< 
		CComObjectRootEx<CComSingleThreadModel>,
	    IDispatchImpl<IMgaReference, &IID_IMgaReference, &LIBID_MGALib> >,
	public ISupportErrorInfoImpl<&IID_IMgaReference>   {
public:
	//##ModelId=3C5AA0890384
	CMgaReference()
	{
	}


DECLARE_PROTECT_FINAL_CONSTRUCT()

BEGIN_COM_MAP(CMgaReference)
	COM_INTERFACE_ENTRY(IMgaReference)
	COM_INTERFACE_ENTRY_IID(IID_IMgaObject,IMgaReference)
	COM_INTERFACE_ENTRY_IID(IID_IMgaFCO,IMgaReference)
	COM_INTERFACE_ENTRY(IDispatch)
	COM_INTERFACE_ENTRY_IID(IID_ISupportErrorInfo, IMyErrorInfoBase)
END_COM_MAP()

// IMgaReference
public:
	//##ModelId=3C5AA0890385
	STDMETHOD(get_Referred)(IMgaFCO * *pVal)			{ return inFCO->get_Referred(pVal); }
	//##ModelId=3C5AA0890390
	STDMETHOD(put_Referred)(IMgaFCO * newVal)			{ return inFCO->put_Referred(newVal); }
	//##ModelId=3C5AA08903A2
	STDMETHOD(get_RefAspect)(IMgaMetaAspect **pVal)		{ return inFCO->get_RefAspect(pVal); }
	//##ModelId=3C5AA08903AC
	STDMETHOD(put_RefAspect)(IMgaMetaAspect * newVal)	{ return inFCO->put_RefAspect(newVal); }
	//##ModelId=3C5AA08903B6
	STDMETHOD(get_UsedByConns)(IMgaConnPoints **pVal)	{ return inFCO->get_UsedByConns(pVal); }
	//##ModelId=3C5AA08903C1
	STDMETHOD(CompareToBase)(short *status)				{ return inFCO->RefCompareToBase(status); }
	//##ModelId=3C5AA08903CC
    STDMETHOD(RevertToBase)()							{ return inFCO->RefRevertToBase(); }
};

//##ModelId=3C5AA08903DE
class putreftask : public DeriveTreeTask {
	//##ModelId=3C5AA08A0001
	bool Do(CoreObj self, vector<CoreObj> *peers = NULL);
public:
	// isext is true if the relation is sure to be external, false if not known
	//##ModelId=3C5AA08A0015
	putreftask(bool isext)  { masterattr = ATTRID_MASTEROBJ; if(isext) endreserve = 1; };
};

#endif //__MGAREFERENCE_H_
