#if !defined(AFX_SELCONF_H__C00FC7AA_4D0A_4DC6_946B_BFFF99DD2CB3__INCLUDED_)
#define AFX_SELCONF_H__C00FC7AA_4D0A_4DC6_946B_BFFF99DD2CB3__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// SelConf.h : header file
//
#include "resource.h"
#include "Table.h"
#include <AFXCMN.H>
#include <afxtempl.h>
#include "string"
#include "vector"
#include "map"

typedef struct
{
	int id;
	CString s;
	int cliqueId;
	bool val;
	const void * ptr;
} entry;

typedef CTypedPtrList<CPtrList, entry*> CEntryList;
/////////////////////////////////////////////////////////////////////////////
// SelConf dialog

class SelConf : public CDialog
{
// Construction
public:
	SelConf( unsigned int configs, CWnd* pParent = NULL);   // standard constructor
	~SelConf();

// Dialog Data
	//{{AFX_DATA(SelConf)
	enum { IDD = IDD_DIALOG1 };
	CComboBox	m_config;
	//}}AFX_DATA


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(SelConf)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
public:
	int addEntry( CString& role, int clique, bool in, const void * ptr);
	bool getEntry( int row, CString& role, bool& in, const void * &ptr);

	void addConfigs( std::vector< std::string >& configs);
	int findAmongConfigs( std::string& config_name);

	std::string m_currSelConfigStr;

	void getDescsAncs( bool which, int changed, std::vector< int > & res);

protected:
	const int m_numberOfConfigs;
	static int m_lastId;
	CEntryList m_entries;

	void fillUpTable(); // copies data to
	void getDataFromTable(); // copies data from m_table
	CTable m_table;

	void saveUserPref( bool check);
	void refreshTable();
	
	std::vector< std::string > m_configStrings;
	// Generated message map functions
	//{{AFX_MSG(SelConf)
	virtual BOOL OnInitDialog();
	virtual void OnOK();
	afx_msg void OnEditupdateCombo1();
	afx_msg void OnCloseupCombo1();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_SELCONF_H__C00FC7AA_4D0A_4DC6_946B_BFFF99DD2CB3__INCLUDED_)
