// AspectPage.cpp : implementation file
//

#include "stdafx.h"
#include "aspectspectbl.h"
#include "aspectpage.h"



#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAspectPage property page

//IMPLEMENT_DYNCREATE(CAspectPage, CPropertyPage)

CAspectPage::CAspectPage() : CPropertyPage(IDD_ASPECT_PAGE)
{
	//{{AFX_DATA_INIT(CAspectPage)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}


CAspectPage::~CAspectPage()
{
	POSITION pos = entries.GetHeadPosition();
	while (pos) {
		delete entries.GetNext(pos);
	}
	entries.RemoveAll();
}

void CAspectPage::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAspectPage)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CAspectPage, CPropertyPage)
	//{{AFX_MSG_MAP(CAspectPage)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CAspectPage message handlers

CString CAspectPage::GetAspectName() {
	return aspectName;
}

void CAspectPage::SetAspectName(CString name) {
	aspectName = name;
}

BOOL CAspectPage::OnInitDialog() 
{
	CPropertyPage::OnInitDialog();
	
	// TODO: Add extra initialization here

	CRect loc;
	this->GetClientRect(&loc);
	loc.DeflateRect(10, 10);
	aspectTable.Create(WS_CHILD|WS_VISIBLE|WS_BORDER/*|LVS_EDITLABELS*/|LVS_REPORT|LVS_SINGLESEL, loc, this, 1);
	POSITION pos = entries.GetHeadPosition();
	while (pos) {
		entry	*e = entries.GetNext(pos);
		aspectTable.AddRow(e->rowID, e->roleName, e->kindAspect, e->isPrimary);
	}

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CAspectPage::AddEntry(int rowID, CString roleName, CString kindAspect, CString isPrimary, const void * ptr)
{
	entry* newent = new entry;;

	newent->rowID = rowID;

	newent->roleName = roleName;
	newent->kindAspect = kindAspect;
	newent->isPrimary = isPrimary;
	newent->ptr = ptr;

	entries.AddTail(newent);
}


bool CAspectPage::GetEntry(int rowID, CString &roleName, CString& kindAspect, CString& isPrimary, const void * &ptr)
{
	bool retval = false;

	POSITION pos = entries.GetHeadPosition();
	while (pos) {
		entry	*e = entries.GetNext(pos);
		if (e->rowID == rowID) {
			roleName = e->roleName;
			kindAspect = e->kindAspect;
			isPrimary = e->isPrimary;
			ptr = e->ptr;
			retval = true;
		}
	}
	return retval;
}

void CAspectPage::OnOK() 
{
	// TODO: Add your specialized code here and/or call the base class
	POSITION pos = entries.GetHeadPosition();
	while (pos) {
		entry	*e = entries.GetNext(pos);
		aspectTable.GetRow(e->rowID, e->roleName, e->kindAspect, e->isPrimary);
	}
	
	CPropertyPage::OnOK();
}
